//+------------------------------------------------------------------+
//|                                                   Perceptron.mq4 |
//|                               Copyright  2008, Yury V. Reshetov |
//|                                                  http://bigfx.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Yury V. Reshetov"
#property link      "http://bigfx.ru"

#property indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  Green
#property  indicator_color2  Blue

//---- input parameters
extern int    x1 = 6;
extern int    x2 = 50;
extern int    x3 = 175;
extern int    x4 = 143;
//---- indicator buffers
double ExtBuffer[];
double ExtBuffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- additional buffers are used for counting
   IndicatorBuffers(2);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_LINE);
   //IndicatorDigits(Digits+2);
//---- indicator buffers mapping
   SetIndexBuffer(0, ExtBuffer);
   SetIndexBuffer(1, ExtBuffer1);
//---- drawing settings
//----
   IndicatorDigits(6);
   SetIndexDrawBegin(0,38);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("Perceptron");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Accelerator/Decelerator Oscillator                               |
//+------------------------------------------------------------------+
int start()
  {
   int    limit;
   int    counted_bars=IndicatorCounted();
   double k = x1 - 100;
   double ac = 0;
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   for(int i = limit - 1; i >= 0; i--){
      ac = iAC(Symbol(), 0, i);
      ExtBuffer[i] = ac - perceptron(i) / k;
      ExtBuffer1[i] = ac;
     }
//---- done
   return(0);
  }
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| The PERCEPTRON - a perceiving and recognizing function           |
//+------------------------------------------------------------------+
double perceptron(int i) {
   double w1 = x1 - 100;
   double w2 = x2 - 100;
   double w3 = x3 - 100;
   double w4 = x4 - 100;
   double a1 = iAC(Symbol(), 0, i);
   double a2 = iAC(Symbol(), 0, i + 7);
   double a3 = iAC(Symbol(), 0, i + 14);
   double a4 = iAC(Symbol(), 0, i + 21);
   return(w1 * a1 + w2 * a2 + w3 * a3 + w4 * a4);
}
//+------------------------------------------------------------------+


